aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/mpc85xx/base-files/etc
diff options
context:
space:
mode:
Diffstat (limited to 'target/linux/mpc85xx/base-files/etc')
-rw-r--r--target/linux/mpc85xx/base-files/etc/diag.sh35
-rw-r--r--target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom71
-rw-r--r--target/linux/mpc85xx/base-files/etc/uci-defaults/02_network31
3 files changed, 137 insertions, 0 deletions
diff --git a/target/linux/mpc85xx/base-files/etc/diag.sh b/target/linux/mpc85xx/base-files/etc/diag.sh
new file mode 100644
index 0000000..1107763
--- /dev/null
+++ b/target/linux/mpc85xx/base-files/etc/diag.sh
@@ -0,0 +1,35 @@
+#!/bin/sh
+# Copyright (C) 2013 OpenWrt.org
+
+. /lib/functions/leds.sh
+. /lib/mpc85xx.sh
+
+get_status_led() {
+ case $(mpc85xx_board_name) in
+ tl-wdr4900-v1)
+ status_led="tp-link:blue:system"
+ ;;
+ esac
+}
+
+set_state() {
+ get_status_led
+
+ case "$1" in
+ preinit)
+ status_led_blink_preinit
+ ;;
+
+ failsafe)
+ status_led_blink_failsafe
+ ;;
+
+ preinit_regular)
+ status_led_blink_preinit_regular
+ ;;
+
+ done)
+ status_led_on
+ ;;
+ esac
+}
diff --git a/target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom b/target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
new file mode 100644
index 0000000..0baec28
--- /dev/null
+++ b/target/linux/mpc85xx/base-files/etc/hotplug.d/firmware/10-ath9k-eeprom
@@ -0,0 +1,71 @@
+#!/bin/sh
+
+FW_FILE="/lib/firmware/$FIRMWARE"
+
+ath9k_eeprom_die() {
+ echo "ath9k eeprom: " "$*" >&2
+ exit 1
+}
+
+ath9k_eeprom_extract() {
+ local part=$1
+ local offset=$2
+ local count=$3
+ local mtd
+
+ . /lib/functions.sh
+ . /lib/functions/system.sh
+
+ mtd=$(find_mtd_chardev $part)
+ [ -n "$mtd" ] || \
+ ath9k_eeprom_die "no mtd device found for partition $part"
+
+ dd if=$mtd bs=$offset skip=1 count=1 2>/dev/null | dd of=$FW_FILE bs=$count count=1 2>/dev/null || \
+ ath9k_eeprom_die "failed to extract from $mtd"
+}
+
+tpl_set_wireless_mac()
+{
+ local offset=$1
+ local mac
+
+ . /lib/functions.sh
+ . /lib/functions/system.sh
+
+ mac=$(mtd_get_mac_binary u-boot 326656)
+ mac=$(macaddr_add $mac $offset)
+
+ macaddr_2bin $mac | dd bs=1 count=6 seek=2 conv=notrunc of=$FW_FILE 2>/dev/null
+}
+
+[ -e $FW_FILE ] && exit 0
+
+. /lib/mpc85xx.sh
+
+board=$(mpc85xx_board_name)
+
+case "$FIRMWARE" in
+"pci_wmac0.eeprom")
+ case $board in
+ tl-wdr4900-v1)
+ ath9k_eeprom_extract "caldata" 4096 2048
+ tpl_set_wireless_mac 0
+ ;;
+ *)
+ ath9k_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+
+"pci_wmac1.eeprom")
+ case $board in
+ tl-wdr4900-v1)
+ ath9k_eeprom_extract "caldata" 20480 2048
+ tpl_set_wireless_mac -1
+ ;;
+ *)
+ ath9k_eeprom_die "board $board is not supported yet"
+ ;;
+ esac
+ ;;
+esac
diff --git a/target/linux/mpc85xx/base-files/etc/uci-defaults/02_network b/target/linux/mpc85xx/base-files/etc/uci-defaults/02_network
new file mode 100644
index 0000000..525a552
--- /dev/null
+++ b/target/linux/mpc85xx/base-files/etc/uci-defaults/02_network
@@ -0,0 +1,31 @@
+#!/bin/sh
+# Copyright (C) 2014 OpenWrt.org
+
+[ -e /etc/config/network ] && exit 0
+
+touch /etc/config/network
+
+. /lib/functions/uci-defaults.sh
+. /lib/mpc85xx.sh
+. /lib/functions.sh
+. /lib/functions/system.sh
+
+ucidef_set_interface_loopback
+
+board=$(mpc85xx_board_name)
+
+case "$board" in
+tl-wdr4900-v1)
+ ucidef_set_interfaces_lan_wan "eth0.1" "eth0.2"
+ ucidef_add_switch "switch0" "1" "1"
+ ucidef_add_switch_vlan "switch0" "1" "0t 2 3 4 5"
+ ucidef_add_switch_vlan "switch0" "2" "0t 1"
+ ;;
+*)
+ ucidef_set_interfaces_lan_wan "eth0" "eth1"
+ ;;
+esac
+
+uci commit network
+
+exit 0